package org.vlescience.webservices.deployment.client;
import org.vlescience.webservices.deployment.DeploymentPortType;
import org.vlescience.webservices.deployment.service.DeploymentServiceLocator;
import org.globus.wsrf.client.BaseClient;
import org.apache.axis.types.URI;
//import java.net.URI;
import org.apache.commons.cli.ParseException;
import org.apache.commons.cli.CommandLine;
import org.globus.wsrf.utils.FaultHelper;
import javax.xml.rpc.Stub;
import org.globus.wsrf.impl.security.authorization.NoAuthorization;
import org.globus.wsrf.security.Constants;

public class DeployUrl extends BaseClient {

    final static DeploymentServiceLocator locator = 
	new DeploymentServiceLocator();
    
    final static DeployUrl client = new DeployUrl();

    public static void main(String args[]) {
	String serviceurl;

        // first, parse the commandline
        try {
            CommandLine line = client.parse(args);
	    serviceurl = line.getOptionValue('s');
	    locator.setdeploymentPortTypePortEndpointAddress(serviceurl);
        } catch(ParseException e) {
            System.err.println("Parsing failed: " + e.getMessage());
            System.exit(1);
        } catch (Exception e) {
            System.err.println("Error: " + e.getMessage());
            System.exit(1);
        }

        try {

            // create the note
            DeploymentPortType port = locator.getdeploymentPortTypePort();
	    ((Stub)port)._setProperty(Constants.GSI_SEC_CONV,Constants.ENCRYPTION);
	    ((Stub)port)._setProperty(Constants.AUTHORIZATION,NoAuthorization.getInstance());
	    String out = port.deploy(new URI("http://foo.bar/"));
            System.out.println("The webservice responds: " + out);

        } catch(Exception e) {
            if (client.isDebugMode()) {
                FaultHelper.printStackTrace(e);
            } else {
                System.err.println("Error: " + FaultHelper.getMessage(e));
            }
        }

    }

}
